/*
This file is auto-generated by OWL2Go (https://git.rwth-aachen.de/acs/public/ontology/owl/owl2go).

Copyright 2020 Institute for Automation of Complex Power Systems,
E.ON Energy Research Center, RWTH Aachen University

This project is licensed under either of
- Apache License, Version 2.0
- MIT License
at your option.

Apache License, Version 2.0:

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

MIT License:

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/

package ontology

import (
	"errors"
	"git.rwth-aachen.de/acs/public/ontology/owl/owl2go/pkg/rdf"
	"git.rwth-aachen.de/acs/public/ontology/owl/owl2go/pkg/owl"
	"strings"
)

// TimeGeneralDurationDescription Description of temporal extent structured with separate values for the various elements of a calendar-clock system.
type TimeGeneralDurationDescription interface {
	TimeTemporalDuration
	timeHasTRSSingleTimeTRS
	timeDaysSinglefloat64
	timeHoursSinglefloat64
	timeMinutesSinglefloat64
	timeMonthsSinglefloat64
	timeSecondsSinglefloat64
	timeWeeksSinglefloat64
	timeYearsSinglefloat64
	IsTimeGeneralDurationDescription() bool // indicates base class
}

// sTimeGeneralDurationDescription Description of temporal extent structured with separate values for the various elements of a calendar-clock system.
type sTimeGeneralDurationDescription struct {
	propCommon
	propTimeHasTRSBaseTimeTRSTypeTimeTRSSingleTimeTRS
	propTimeDaysBasefloat64Typefloat64Singlefloat64
	propTimeHoursBasefloat64Typefloat64Singlefloat64
	propTimeMinutesBasefloat64Typefloat64Singlefloat64
	propTimeMonthsBasefloat64Typefloat64Singlefloat64
	propTimeSecondsBasefloat64Typefloat64Singlefloat64
	propTimeWeeksBasefloat64Typefloat64Singlefloat64
	propTimeYearsBasefloat64Typefloat64Singlefloat64
}

// NewTimeGeneralDurationDescription creates a new TimeGeneralDurationDescription
func (mod *Model) NewTimeGeneralDurationDescription(iri string) (ret TimeGeneralDurationDescription, err error) {
	if mod.Exist(iri) {
		err = errors.New("Resource already exists")
		return
	}
	res := &sTimeGeneralDurationDescription{}
	pc := propCommon{iri: iri, typ: "TimeGeneralDurationDescription", model: mod}
	res.propCommon = pc
	mod.addTimeGeneralDurationDescription(res)
	res.makeMaps()
	ret = res
	return
}

// makeMaps creates initiliazes maps
func (res *sTimeGeneralDurationDescription) makeMaps() {
	return
}

// addTimeGeneralDurationDescription adds TimeGeneralDurationDescription to model
func (mod *Model) addTimeGeneralDurationDescription(res TimeGeneralDurationDescription) {
	mod.mTimeGeneralDurationDescription[res.IRI()] = res
	mod.addTimeTemporalDuration(res)
	return
}

// TimeGeneralDurationDescription returns all resources with given prefix
func (mod *Model) TimeGeneralDurationDescription(prefix string) (res []TimeGeneralDurationDescription) {
	for i := range mod.mTimeGeneralDurationDescription {
		if strings.HasPrefix(i, prefix) {
			res = append(res, mod.mTimeGeneralDurationDescription[i])
		}
	}
	return
}

// RemoveObject deletes all its references in this object
func (res *sTimeGeneralDurationDescription) RemoveObject(obj owl.Thing, prop string) {
	switch prop {
	case "http://www.w3.org/2006/time#hasTRS":
		res.propTimeHasTRSBaseTimeTRSTypeTimeTRSSingleTimeTRS.removeObject(obj)
	default:
	}
	return
}

// isTimeGeneralDurationDescription indicates base class
func (res *sTimeGeneralDurationDescription) IsTimeGeneralDurationDescription() bool {
	return true
}

// isTimeTemporalDuration indicates base class
func (res *sTimeGeneralDurationDescription) IsTimeTemporalDuration() bool {
	return true
}

// InitFromNode initializes the resource from a graph node
func (res *sTimeGeneralDurationDescription) InitFromNode(node *rdf.Node) (err error) {
	for i := range node.Edge {
		res.propsInit(node.Edge[i])
	}
	return
}

// propsInit initializes the property from a graph node
func (res *sTimeGeneralDurationDescription) propsInit(pred *rdf.Edge) (err error) {
	switch pred.Pred.String() {
	case "http://www.w3.org/2006/time#hasTRS":
		res.propTimeHasTRSBaseTimeTRSTypeTimeTRSSingleTimeTRS.init(res.model, pred.Object.Term.String())
	case "http://www.w3.org/2006/time#days":
		res.propTimeDaysBasefloat64Typefloat64Singlefloat64.init(pred.Object.Term.String())
	case "http://www.w3.org/2006/time#hours":
		res.propTimeHoursBasefloat64Typefloat64Singlefloat64.init(pred.Object.Term.String())
	case "http://www.w3.org/2006/time#minutes":
		res.propTimeMinutesBasefloat64Typefloat64Singlefloat64.init(pred.Object.Term.String())
	case "http://www.w3.org/2006/time#months":
		res.propTimeMonthsBasefloat64Typefloat64Singlefloat64.init(pred.Object.Term.String())
	case "http://www.w3.org/2006/time#seconds":
		res.propTimeSecondsBasefloat64Typefloat64Singlefloat64.init(pred.Object.Term.String())
	case "http://www.w3.org/2006/time#weeks":
		res.propTimeWeeksBasefloat64Typefloat64Singlefloat64.init(pred.Object.Term.String())
	case "http://www.w3.org/2006/time#years":
		res.propTimeYearsBasefloat64Typefloat64Singlefloat64.init(pred.Object.Term.String())
	default:
	}
	return
}

// ToGraph creates a new owl graph node and adds it to the graph
func (res *sTimeGeneralDurationDescription) ToGraph(g *rdf.Graph) {
	node := owl.AddObjectToGraph(g, "http://www.w3.org/2006/time#GeneralDurationDescription", res)
	res.propsToGraph(node, g)
	return
}

// propsToGraph adds all properties to the graph
func (res *sTimeGeneralDurationDescription) propsToGraph(node *rdf.Node, g *rdf.Graph) {
	res.propTimeHasTRSBaseTimeTRSTypeTimeTRSSingleTimeTRS.toGraph(node, g)
	res.propTimeDaysBasefloat64Typefloat64Singlefloat64.toGraph(node, g)
	res.propTimeHoursBasefloat64Typefloat64Singlefloat64.toGraph(node, g)
	res.propTimeMinutesBasefloat64Typefloat64Singlefloat64.toGraph(node, g)
	res.propTimeMonthsBasefloat64Typefloat64Singlefloat64.toGraph(node, g)
	res.propTimeSecondsBasefloat64Typefloat64Singlefloat64.toGraph(node, g)
	res.propTimeWeeksBasefloat64Typefloat64Singlefloat64.toGraph(node, g)
	res.propTimeYearsBasefloat64Typefloat64Singlefloat64.toGraph(node, g)
	return
}

// String prints the object into a string
func (res *sTimeGeneralDurationDescription) String() (ret string) {
	ret = res.iri + " " + "TimeGeneralDurationDescription\n"
	ret += res.propsString()
	return
}

// propsString prints the object into a string
func (res *sTimeGeneralDurationDescription) propsString() (ret string) {
	ret = ""
	ret += res.propTimeHasTRSBaseTimeTRSTypeTimeTRSSingleTimeTRS.String()
	ret += res.propTimeDaysBasefloat64Typefloat64Singlefloat64.String()
	ret += res.propTimeHoursBasefloat64Typefloat64Singlefloat64.String()
	ret += res.propTimeMinutesBasefloat64Typefloat64Singlefloat64.String()
	ret += res.propTimeMonthsBasefloat64Typefloat64Singlefloat64.String()
	ret += res.propTimeSecondsBasefloat64Typefloat64Singlefloat64.String()
	ret += res.propTimeWeeksBasefloat64Typefloat64Singlefloat64.String()
	ret += res.propTimeYearsBasefloat64Typefloat64Singlefloat64.String()
	return
}


